/* Copyright Andy Mitchell 2007, 2008. No warranties */

function ConversationUI(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
	this._labels = gtdinboxPage._labels;
	this._multiToOne = new MultiToOne(gtdinboxPage, 300);
	
	this._eventObservers = new GtdEventObservers(this);
	
	this._gtdinboxPage._moreActionsMenu.addEventHandler( this, "actionlist-manual-click", this.manualThreadLabelChange );
	//this._labels.addEventHandler( this, "refresh-labels", this.refreshLabels );
	
	this.threadListCustomUIs = [];
	
	this._searcher = new Searcher(gtdinboxPage);
}

ConversationUI.prototype.viewChange = function(gmail, callback){

try{
	// Make sure we're still embedded
	
	
	var doc = this._gtdinboxPage.gmailDOM.element("document", gmail);
	
	

	var match = this._doc.defaultView.top.location.href.match(/\/(#inbox|#search|#sent)(\/.+)?\/(.+)$/);
	var id = match? match[match.length-1] : "";

	this._threadActions = new ThreadActionsUI(this._gtdinboxPage);
	
	if( !this._gtdinboxPage.settings.ui.hide.finishButton ){
		// Add in the Finish button
		var fAddArchive = GIPROTOTYPE.bind(this, function(elArchive){
				if( elArchive ){
					var elFinish = this._threadActions.getFinishedButton();
					elFinish.className = elArchive.className;
					elArchive.parentNode.insertBefore( elFinish, elArchive.nextSibling );
					//elArchive.innerHTML = elArchive.innerHTML.replace(/<[^>]+>/g, "");	// Strip bold
				}
			});
		fAddArchive(this._gtdinboxPage.gmailDOM.element("archive-button"));
		fAddArchive(this._gtdinboxPage.gmailDOM.element("archive-button-footer"));
	}
	
	
	
	var thread = this._gtdinboxPage._threadList.getThreadById(id);
	if( !thread ){ // Create a stand in:
		var thread = new Thread(this._gtdinboxPage._threadList, id);
		var elSubject = this._gtdinboxPage.gmailDOM.element("conversation-subject");
		thread.subject = elSubject.innerHTML;
		this.refresh(thread);
		this._gtdinboxPage._threadList.getThreadById(id, GIPROTOTYPE.bind(this, function(thread2){
				if( thread2 ){
					this.refresh(thread2);
				}else{
					this._gtdinboxPage._moreActionsMenu.getActiveLabels(GIPROTOTYPE.bind(this, function(activeLabels){
						thread.verifyLabels(activeLabels);
						this._gtdinboxPage._threadList.addThread(thread, true);
						this.refresh(thread);
					}));
				}
			}));
	}else{
		this.refresh(thread);
	}
	
	
	if( !this._gtdinboxPage.settings.ui.hide.conversationDeleteMoveNext ) this._gtdinboxPage._moreActionsMenu.addCustomEntry("cv-deletemovenext", this._gtdinboxPage.stringBundle.getString("Conversation.DeleteMoveNext"), this._gtdinboxPage.stringBundle.getString("Conversation.DeleteMoveNext.Tooltip"), GIPROTOTYPE.bind(this, this.deleteMoveNext) );
	if( !this._gtdinboxPage.settings.ui.hide.conversationBump ) this._gtdinboxPage._moreActionsMenu.addCustomEntry("cv-bump", this._gtdinboxPage.stringBundle.getString("Conversation.Bump"), this._gtdinboxPage.stringBundle.getString("Conversation.Bump.Tooltip"), GIPROTOTYPE.bind(this, this.bump) );
	if( !this._gtdinboxPage.settings.ui.hide.removeAllLabels ) this._gtdinboxPage._moreActionsMenu.addCustomEntry("cv-removealllabels", this._gtdinboxPage.stringBundle.getString("MoreActions.RemoveAllLabels"), this._gtdinboxPage.stringBundle.getString("MoreActions.RemoveAllLabels.Tooltip"), GIPROTOTYPE.bind(this, function(){

			try{
			
				this._gtdinboxPage._lightbox.setType("updatingmessages");
				this._gtdinboxPage._lightbox.active(true);
				var fOnDone = GIPROTOTYPE.bind( this, function(){
					this._gtdinboxPage._lightbox.active(false);
					this.refreshLabels();
				});

				// Get current labels
				var labels = [];
				this._gtdinboxPage._moreActionsMenu.doMoreAction( function(el){
					if( el.getAttribute("act")=="13" ){
						var labelname = el.innerHTML.replace(/\<[^>]+?\>/g, "");
						labels.push( labelname );
					}
				}, GIPROTOTYPE.bind( this, function(){			
					// Remove those labels:
					for( var i = 0; i < labels.length; i++ ) this.thread.removeLabel(labels[i], null, null, true);
					this._gtdinboxPage._moreActionsMenu.removeLabels(labels, fOnDone);
				}) );

			
				
			}catch(e){
				if( GTDDEBUGMODE ) alert("conversationui viewChange removeAllLabels\n" + e.toString());
			}
		}));
}catch(e){
	if( GTDDEBUGMODE ) alert("conversationui viewChange\n" + e.toString());
}

};
	
ConversationUI.prototype.refresh = function(thread){
try{
	

	
	
	this.thread = thread;
	
	this.thread.initEventHandler();
	this.thread.eventHandlers.reset();	// get it exclusively for us
	
	
	this.thread.addEventHandler( this, "addLabel", this.refreshLabels );
	this.thread.addEventHandler( this, "removeLabel", this.refreshLabels );
	
	this._gtdinboxPage._recentItems.addThread(this.thread);
	
	
	if( !this._gtdinboxPage.settings.ui.hide.conversationLabels ){
		// Label Selection Header
		if( this.elH1 ){
			this._listenHeaderEvents(false);
		}
		this.elH1 = this._gtdinboxPage.gmailDOM.element("conversation-header");
		if( !this.elH1 ) return;
		this._listenHeaderEvents(true);
		
		var elHeader = this.elH1.parentNode;
		if( elHeader.getElementsByTagName("DIV")[0] && elHeader.getElementsByTagName("DIV")[0].className.indexOf("conversation-header")>-1 ){	// already modified
			return;
		}
		
		var elConversationHeader = this._doc.createElement("DIV");
			elConversationHeader.className = "conversation-header";
		elHeader.appendChild( elConversationHeader );
		
		if( !this._labelSelect ){
			this._threadActions.refresh(this.thread);
			this._labelSelect = new LabelSelectUI( this._gtdinboxPage, null, null, this._threadActions ); 
			this._labelSelect.addEventHandler(this, "click-label", this.toggleLabel);

		}
		elConversationHeader.appendChild( this._labelSelect.el );
		
		// Add below conversation (just Statuses)
		if( !this._elConversationFooter ){
			this._elConversationFooter = this._doc.createElement("DIV");
			this._elConversationFooter.className = "conversation-footer";
		}
		var elBelowConversation = this._gtdinboxPage.gmailDOM.element("conversation-below-reply");
		elBelowConversation.appendChild( this._elConversationFooter );
		if( GTDDEVMODE ){
			if( !this._labelSelect2 ){
				this._threadActions.refresh(this.thread);
				this._labelSelect2 = new LabelSelectUI( this._gtdinboxPage, null, null, this._threadActions, true, {'Statuses':true} ); 
				this._labelSelect2.addEventHandler(this, "click-label", this.toggleLabel);
				this._elConversationFooter.appendChild( this._labelSelect2.el );
			}
		}
		
	}
	
	
	
	// Detect clicks to conversation
	if( this._elConversation ){
		this._eventObservers.stopObserving( this._elConversation, "click", this._clickConversation, false );
	}
	this._elConversation = this._gtdinboxPage.gmailDOM.element("ActiveViewElement");
	this._eventObservers.observe( this._elConversation, "click", this._clickConversation, false );
	
	
	
	
	// Add in Related Items
	if( GTDDEVMODE ){
		if( !this._conversationRelated ) this._conversationRelated = new ConversationRelatedUI(this._gtdinboxPage);
		this._conversationRelated.refresh(this.thread);
		
	}
	
	
	if( !this._gtdinboxPage.settings.ui.hide.conversationReply ){
		// Hook up Reply to Self
		this.integrateReplyRows();
	}
	
	
	
	if( this.elConversationMessages ){
		this._listenMessageEvents(false);
	}
	
	this.elConversationMessages = this._gtdinboxPage.gmailDOM.element("conversation-messages");
	this._listenMessageEvents(true);
	
	this.refreshLabels();
	

	
}catch(e){
	if( GTDDEBUGMODE ) alert("conversationui refresh\n" + e.toString());
}
};


ConversationUI.prototype.integrateReplyRows = function(){
	// Integrate ReplyToSelf into visible rows
	
	var listening = this._listenMessageEvents();
	if( listening ) this._listenMessageEvents(false);
	var elRows = this._gtdinboxPage.gmailDOM.elements("conversation-reply-rows");
	for( var i = 0; i < elRows.snapshotLength; i++ ){
		var elRow = elRows.snapshotItem(i);
		var row = this._gtdinboxPage.gmailDOM.parseElement("conversation-reply-row", elRow);
		if( row ){
			if( !row.elReplyToSelf ){
				/*
				// NO BUMP BECAUSE IT BRINGS IT BACK INTO INBOX -> UNNECESSARY CRUTCH
				if( i==elRows.snapshotLength-1 ){
					var elBump = this._doc.createElement("BUTTON");
						elBump.className = "gtd-bump";
						elBump.innerHTML = this._gtdinboxPage.stringBundle.getString("Conversation.Bump");
					row.elForward.parentNode.insertBefore(elBump, row.elForward.nextSibling);
				}
				*/
				this._eventObservers.observe(elRow, "mouseup", this._clickReplyRow, false);
				var elReplyToSelf = this._doc.createElement("TD");
				elReplyToSelf.innerHTML = "<div class='reply-to-self'><img name='reply-to-self' class='eChx3e INkyme' src='images/cleardot.gif' /><span name='reply-to-self'>" + this._gtdinboxPage.stringBundle.getString("Conversation.ReplyToSelf") + "</span></div>";
				row.elForward.parentNode.insertBefore(elReplyToSelf, row.elForward.nextSibling);
			}else if( !row.elTable ){	// Ensure it isn't highlighted
				row.elReplyToSelf.className = "";
			}
		}
	}
	if( listening ) this._listenMessageEvents(true);
	
	
};

ConversationUI.prototype._listenMessageEvents = function(v){
	
	if( typeof v=="undefined" ){
		return this._listeningMessageEvents;
	}
	if( v ){
		this._eventObservers.observe( this.elConversationMessages, "DOMNodeInserted", this._modifyMessages, false );
		this._eventObservers.observe( this.elConversationMessages, "DOMNodeRemoved", this._modifyMessages, false );
	}else{
		this._eventObservers.stopObserving( this.elConversationMessages, "DOMNodeInserted", this._modifyMessages, false );
		this._eventObservers.stopObserving( this.elConversationMessages, "DOMNodeRemoved", this._modifyMessages, false );
	}
	this._listeningMessageEvents = v;
	
};
ConversationUI.prototype._listenHeaderEvents = function(v){
	
	if( typeof v=="undefined" ){
		return this._listeningHeaderEvents;
	}
	if( v ){
		this._eventObservers.observe( this.elH1, "click", this._clickHeader, false );
		//this._eventObservers.observe( this.elH1, "DOMNodeInserted", this._modifyHeader, false );
		//this._eventObservers.observe( this.elH1, "DOMNodeRemoved", this._modifyHeader, false );
	}else{
		this._eventObservers.stopObserving( this.elH1, "click", this._clickHeader, false );
		//this._eventObservers.stopObserving( this.elH1, "DOMNodeInserted", this._modifyHeader, false );
		//this._eventObservers.stopObserving( this.elH1, "DOMNodeRemoved", this._modifyHeader, false );
	}
	this._listeningHeaderEvents = v;
	
};

ConversationUI.prototype._modifyMessages = function(){
	this._multiToOne.process("modifyMessages", GIPROTOTYPE.bind(this, this.integrateReplyRows));
};

ConversationUI.prototype._modifyHeader = function(event){
	this._multiToOne.process("modifyHeader", GIPROTOTYPE.bind(this, this.refreshLabels));
};
ConversationUI.prototype._clickHeader = function(event){
	var el = GIPROTOTYPE.element(event);
	
	if( this._gtdinboxPage.gmailDOM.test("conversation-x",el) ){	// It's a remove
		var name = el.getAttribute("name");
		this.thread.removeLabel(name, null, null, true);
		//this.refreshLabels();
	}	
};

ConversationUI.prototype.deleteMoveNext = function(){
	// Method #1: Record the current ID, click 'Older', and use GmailDOM to delete the thread id
	// Method #2: Extract search from url, load threads, find next thread; click Delete here and set gmail to load next url
	
try{
	// Click delete on this one:
	
	//var elDelete = this._gtdinboxPage.gmailDOM.element("delete-button");
	//if( !elDelete ) return;
	
	
	var threadActionsUI = new ThreadActionsUI(this._gtdinboxPage, null, true);
	
	// Extract current query; get the range; and take the next 25 entries after this point.
	var range = this._gtdinboxPage.gmailDOM.parseElement( "conversation-range", this._gtdinboxPage.gmailDOM.element("conversation-range") );
		range.end = range.start + 25;
	var search = this._gtdinboxPage.gmailDOM.extractSearchQuery();
	
	this._searcher.search(search, GIPROTOTYPE.bind( this, function(threadList,query){
		
		// Find the current thread id, then the next one
		for( var i = 0; i < threadList._threads.length; i++ ){
			if( threadList._threads[i].id==this.thread.id ){
				if( threadList._threads[i+1] ){
					threadActionsUI._clickDelete();
					//GIPROTOTYPE.doMouseEvent(this._doc, elDelete, "click");
					
					var id = threadList._threads[i+1].id;
					setTimeout( GIPROTOTYPE.bind(this, function(){
						this._gtdinboxPage.gmailDOM.loadThread( id );
						}), 1000 );
					break;
				}
			}
		};

	}), 25, range);
	
	

}catch(e){
	//if( typeof lightbox!="undefined" && lightbox ) lightbox.active(false);
	if( GTDDEBUGMODE ) alert("Conversation UI deleteMoveNext\n" + e.toString());
}

};

ConversationUI.prototype.bump = function(){
try{
	var lightbox = null;
	lightbox = new GtdLightbox(this._gtdinboxPage, this._gtdinboxPage.doc.body);
	lightbox.setType( "processing", {msg:(this._gtdinboxPage.stringBundle.getString("Conversation.Bumping"))} );
	lightbox.active(true);


	var elRows = this._gtdinboxPage.gmailDOM.elements("conversation-reply-rows");
	if( elRows.snapshotLength==0 ) return;
	
	var elRow = elRows.snapshotItem( elRows.snapshotLength - 1 );
	
	var row = this._gtdinboxPage.gmailDOM.parseElement("conversation-reply-row", elRow );
	if( !row ) return;

	GIPROTOTYPE.doMouseEvent(this._doc, row.elReplyToClick, "click");	// expand ite
	var fFollowUp = GIPROTOTYPE.bind(this, function(row2){
			try{
				if( !row2 ) row2 = this._gtdinboxPage.gmailDOM.parseElement("conversation-reply-row", elRow );
				row2.elText.value = this._gtdinboxPage._environment.email;
				GIPROTOTYPE.doMouseEvent(this._doc, row2.elSendButton, "click");
				setTimeout( GIPROTOTYPE.bind(this, function(){
					try{
						if(lightbox) lightbox.active(false);
						var el = this._gtdinboxPage.gmailDOM.element("inbox-link");
						GIPROTOTYPE.doMouseEvent(this._doc, el, "click");	// refresh
					}catch(e){
						if( GTDDEBUGMODE ) alert("Conversation UI clickReplyRow final timeout\n" + e.toString());
					}
				}), 4000 );
			}catch(e){
				if( lightbox ) lightbox.active(false);
			}
		});
	setTimeout( GIPROTOTYPE.bind(this, function(){
			var row = this._gtdinboxPage.gmailDOM.parseElement("conversation-reply-row", elRow );
			if( row.elTable ){	// Loaded Reply
				fFollowUp(row);
			}else{	// Try again
				setTimeout( fFollowUp, 400 );
			}
		}), 100);
}catch(e){
	if( typeof lightbox!="undefined" && lightbox ) lightbox.active(false);
	if( GTDDEBUGMODE ) alert("Conversation UI clickReplyRow\n" + e.toString());
}
};

ConversationUI.prototype._clickConversation = function(event){
	var el = GIPROTOTYPE.element(event);
	
	// See if star was clicked & respond
	if( this._gtdinboxPage.settings.labels.starForNextAction && this._gtdinboxPage.gmailDOM.test("star", el) ){	// It's a star
		// Test to see if star is on/off and respond
		
		
		
		var settings = this._gtdinboxPage.settings;
		var labelNextAction = settings.labels.types.Statuses.prefix + settings.labels.types.Statuses.defaults.NextAction;
		if( this._gtdinboxPage.gmailDOM.test("star-on", el) ){	// its on, add label
			this.thread.addLabel(labelNextAction, null, "moreActions");
			//this._gtdinboxPage._labels.labelThread({labelname:labelNextAction, 'on':true, 'threads':this.thread});
		}else{	// Off, make sure it's off
			this.thread.removeLabel(labelNextAction, null, "moreActions");
			//this._gtdinboxPage._labels.labelThread({labelname:labelNextAction, 'on':false, 'threads':this.thread});
		}
	}

};

ConversationUI.prototype._clickReplyRow = function(event){
try{
	var el = GIPROTOTYPE.element(event);
	var elRow = el;
	while( elRow.parentNode && elRow.nodeName!="TR" ) elRow = elRow.parentNode;
	if( elRow.nodeName!="TR" ) return;
	
	var row = this._gtdinboxPage.gmailDOM.parseElement("conversation-reply-row", elRow );
	if( !row ) return;

	if( el.getAttribute("name")=="reply-to-self" ){	// Clicked Reply to Self
		// Click Reply to setup the row correctly
		// Uncolour the other tabs
		// Hide From/To
		GIPROTOTYPE.doMouseEvent(this._doc, row.elReplyToClick, "click");	// refresh
		var fFollowUp = GIPROTOTYPE.bind(this, function(row2){
				if( !row2 ) row2 = this._gtdinboxPage.gmailDOM.parseElement("conversation-reply-row", elRow );
				row2.elReply.className = "";	// Remove colouration
				row2.elReplyToSelf.className = "reply-to-self-selected";
				row2.elFrom.style.display = "none";
				//row2.elTo.style.display = "none";
				this._lastEmailAddress = row2.elText.value;
				row2.elText.value = this._gtdinboxPage._environment.email.replace("@", "+action@");
			});
		setTimeout( GIPROTOTYPE.bind(this, function(){
				var row = this._gtdinboxPage.gmailDOM.parseElement("conversation-reply-row", elRow );
				if( row.elTable ){	// Loaded Reply
					fFollowUp(row);
				}else{	// Try again
					setTimeout( fFollowUp, 400 );
				}
			}), 100);
	}else if( this._gtdinboxPage.gmailDOM.test("conversation-reply-clicked-item", el) ){ // Clicked Reply or Forward
		// Uncolour ReplyToSelf tab
		// Show From/To
		row.elReplyToSelf.className = "";
		if( row.elTable ){
			row.elFrom.style.display = "";
			//row.elTo.style.display = "";
			if( this._lastEmailAddres ) row.elText.value = this._lastEmailAddress;
		}
	}	
}catch(e){
	if( GTDDEBUGMODE ) alert("Conversation UI clickReplyRow\n" + e.toString());
}
};

ConversationUI.prototype.refreshLabels = function(){

try{
	
	if( this._gtdinboxPage.view("view")!="cv" ) return;
	
	var listening = this._listenHeaderEvents();
	if( listening ) this._listenHeaderEvents(false);
	
	
	if( this._labelSelect ) this._labelSelect.refresh(this.thread);
	if( this._labelSelect2 ) this._labelSelect2.refresh(this.thread);
	/*
	this.thread.refreshData(GIPROTOTYPE.bind(this, function(){
		if( this._labelSelect ) this._labelSelect.refresh(this.thread);
	}), "moreActions");
	*/
	
	if( listening ) this._listenHeaderEvents(true);
	
}catch(e){
	if( GTDDEBUGMODE ) alert("conversation ui refreshLabels\n" + e.toString());
}

};

/*
ConversationUI.prototype.threadUpdate = function(){	
try{
	this.thread.verifyLabels( this._labels.getActiveLabels() );
	if( this._gtdinboxPage.view("view")!="cv" ) return;
	this._labelSelect.refresh(this.thread);
	this._labelSelect.newLabels( this.thread.getUnknownBodyLabels() );
}catch(e){
	if( GTDDEBUGMODE ) alert("conversation ui threadUpdate\n" + e.toString());
}
};
*/
ConversationUI.prototype.manualThreadLabelChange = function(event, label){
	// Called when user manually selects label on drop down
	// Kept seperate from Labels because ThreadList/Conversation would handle it differently

try{
	if( this._gtdinboxPage.view("view")!="cv" ) return;	// i should be active view
	
	if( this.thread ){
		if( label.act=="12" ){
			var callback = null;
			if( label.doArchive || label.label==(this._gtdinboxPage.settings.labels.types.Statuses.prefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.Finished) ){	// clicked finish, archive it
				callback = GIPROTOTYPE.bind(this, function(){
						var threadActionsUI = new ThreadActionsUI(this._gtdinboxPage, null, true);
						threadActionsUI._clickArchive();
					});
			}
			this.thread.addLabel(label.label, callback, null, true);
		}else if(label.act=="13"){
			this.thread.removeLabel(label.label, null, null, true);
		}
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("ConversationUI manualThreadLabelChange\n" + e.toString());
}
};

ConversationUI.prototype.toggleLabel = function(e, label){
try{
	var labelname = label.labelname;
	
	if( this.thread.hasLabel( labelname ) ){
		this.thread.removeLabel( labelname, null, "moreActions" );
	}else{
		var fComplete = GIPROTOTYPE.bind(this, function(){
			if( label.doubleClick || (labelname==(this._gtdinboxPage.settings.labels.types.Statuses.prefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.Finished)) ){	// clicked finish, archive it
				var threadActionsUI = new ThreadActionsUI(this._gtdinboxPage, null, true);
				threadActionsUI._clickArchive();
			}
		});
		this.thread.addLabel( labelname, fComplete, "moreActions" );
	}
	
}catch(e){
	if( GTDDEBUGMODE ) alert("conversationui toggleLabel\n" + e.toString());
}
};

ConversationUI.prototype.destroy = function(){
	if( this._labelSelect ) this._labelSelect.destroy();
	if( this._showHiderLabels) this._showHiderLabels.destroy();
	this._multiToOne.destroy();

	this._eventObservers.destroy();
	
	this.elH1 = null;
	this.thread = null;
	this._labels = null;
	this._doc = null;
	this._gtdinboxPage = null;
}