/* Copyright Andy Mitchell 2007, 2008. No warranties */

function LabelSelectUIDropdown(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
	
	
	this.el = this._doc.createElement("DIV");
		this.el.className = "label-selector-dropdown";
		
}

LabelSelectUIDropdown.prototype.refresh = function(type){
try{

	if( !type ) type = this._type;
	this._type = type;
	if( this._gtdinboxPage._labels.typeBuckets[type] ){
		this.el.style.display = "";
	}else{
		this.el.style.display = "none";
		return;
	}

	
	this.typeBucket = this._gtdinboxPage._labels.getLabelsEl(this._type);
	this.elLabelsAll = this.typeBucket.el;

	
	var elContent = GIPROTOTYPE.getElementsByClassName(this.elLabelsAll, "labels")[0];
	if( this.showHider ) this.showHider._show(false);
	if( !this.showHider || this.showHider.labelTypeName!=type ){
		var elTitle = GIPROTOTYPE.getElementsByClassName(this.elLabelsAll, "title")[0];
		this.showHider = new ShowhiderCombo(this._gtdinboxPage, "label-" + this._type, {doc:this._doc, type:"create", title:elTitle.innerHTML, 'elContent':elContent, show:true});
		this.showHider.el.className += " " + this.elLabelsAll.className;
		//this.showHider = new ShowhiderCombo(this._gtdinboxPage, "label-" + type, {doc:this._doc, type:"attach", el:this.elLabelsAll, titleClass:"title", show:true});
		this.showHider.labelTypeName = type;
		this.showHider.addEventHandler(this, "pre-show", this.preShow);
		this.el.innerHTML = "";
		this.el.appendChild( this.showHider.el );
	}else{
		this.showHider.setContent( elContent ); 
	}
	
	
	
	this.el.style.display = (this.showHider.elContent.innerHTML.length==0)? "none" : "";
	
}catch(e){
	if( GTDDEBUGMODE ) alert("LabelSelectUIDropdown refresh\n" + e.toString());
}
};

LabelSelectUIDropdown.prototype.refreshSelectedCount = function(selectedLabels){
try{
	
	if( this.showHider ){
		if( selectedLabels instanceof Array ) selectedLabels = GIPROTOTYPE.arrayToHash(selectedLabels);
		
		var elContent = this.showHider.elContent;
		var count = 0;
		for( var i = 0; i < elContent.childNodes.length; i++ ){
			var labelname = elContent.childNodes[i].getAttribute("gtdLabelName");
			if( labelname && selectedLabels[labelname] ) count++;
		}
		this.showHider.elTitleTxt.innerHTML = this.showHider.elTitleTxt.innerHTML.replace(/\s\(\d+\)$/, "");
		if( count > 0 ) this.showHider.elTitleTxt.innerHTML += " (" + count + ")";
	}
	
}catch(e){
	if( GTDDEBUGMODE ) alert("LabelSelectUIDropdown refreshSelectedCount\n" + e.toString());
}
};

LabelSelectUIDropdown.prototype.preShow = function(){
	// Run up and down the labels box; closing everything that doesn't lead to a selected label
	
try{
	var elLabels = this.showHider.elContent;
	
	
	for( var i = 0; i < elLabels.childNodes.length; i++ ){
		var elLabel = elLabels.childNodes[i];
		var labelname = elLabel.getAttribute("gtdLabelFullName");
		var label = this.typeBucket.labels[labelname];
		if( !label.parent ) label.closeLabel();
		if( GIPROTOTYPE.hasClassName(elLabel, "selected") ){	// It is selected
			label.openLabelsToHere();
		}
	}
	
	/*
	for( var i = 0; i < elLabels.childNodes.length; i++ ){
		var elLabel = elLabels.childNodes[i];
		var label = elLabel.getAttribute("gtdLabelFullName");
		if( !elLabel.getAttribute("gtdLabelParentName") ){
			this._gtdinboxPage._labels._applyToChildren(elLabel, function(el){
				el.style.display = "none";
				var elTreeImg = GIPROTOTYPE.getElementsByClassName(el, "label-folder-toggle");
				if( elTreeImg && elTreeImg[0] ){
					elTreeImg[0].src = "chrome://gtdinbox/content/collapsetree-closed.png";
					elTreeImg[0].alt = '+';
				}
			}, true);
		}else if( GIPROTOTYPE.hasClassName(elLabel, "selected") ){	// It is selected
			var d = {'seenCount':0}
			this._gtdinboxPage._labels._applyToParent(elLabel, GIPROTOTYPE.bind(this, function(el){
				if( ++d.seenCount==2 ){	// Need to show all my siblings
					var parentName = el.getAttribute("gtdLabelFullName");
					var el2 = el.nextSibling;
					while( el2.nextSibling && el2.getAttribute("gtdLabelParentName")==parentName ){
						el2.style.display = "";
						el2 = el2.nextSibling;
					}
				}
				el.style.display = "";
				var elTreeImg = GIPROTOTYPE.getElementsByClassName(el, "label-folder-toggle");
				if( elTreeImg && elTreeImg[0] ){
					elTreeImg[0].src = "chrome://gtdinbox/content/collapsetree-open.png";
					elTreeImg[0].alt = '-';
				}
			}), true);
			
		}
	}
	*/
	
}catch(e){
	if( GTDDEBUGMODE ) alert("LabelSelectUIDropdown preShow\n" + e.toString());
}	
};

LabelSelectUIDropdown.prototype.hideCombos = function(){
	if( this.showHider ) this.showHider._show(false);
}

LabelSelectUIDropdown.prototype.destroy = function(){
	this.showHider.destroy();
}