/* Copyright Andy Mitchell 2007, 2008. No warranties */

function LabelSelectUIInline(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
	this._eventObservers = new GtdEventObservers(this);
	
	this.el = this._doc.createElement("DIV");
		this.el.className = "label-selector-inline";
	
	this._elPopupCache = {};
	
	this.elPopup = this._doc.createElement("DIV");
		this.elPopup.className = "label-selector-popup labels-group";
	this.el.appendChild( this.elPopup );
	this.popuper = new GtdPopuper( gtdinboxPage, this.elPopup, this );
		
	this._eventObservers.observe( this.el, "click", this._click, false );
};

LabelSelectUIInline.prototype.refresh = function(type, labels){

try{

	if( !type ) type = this._type;
	this._type = type;
	if( this._gtdinboxPage._labels.typeBuckets[type] ){
		this.el.style.display = "";
	}else{
		this.el.style.display = "none";
		return;
	}


	var customLabels = true;
	if( !labels ){
		customLabels = false;
		labels = this._gtdinboxPage._labels.getLabelsArray(type, true);
	}
	
	var isElPopupAttachedToEl = false;
	if( this.elPopup.parentNode==this.el ){
		this.elPopup.parentNode.removeChild( this.elPopup );
		isElPopupAttachedToEl = true;
	}
	if( this.elLabelsAll ) this.el.removeChild( this.elLabelsAll );
	this.el.innerHTML = "";
	if( isElPopupAttachedToEl ) this.el.appendChild( this.elPopup );
		
	var labelsObjectsHash = this._gtdinboxPage._labels.getLabelsHash(type);
	var labelsAdded = {};
	
	
	this.labelCount = 0;
	for( var i = 0; i < labels.length; i++ ){
		var l = labels[i];
		if( !labelsObjectsHash[l] ){
			l = null;
		}else{
			while( labelsObjectsHash[l].parent ){
				l = labelsObjectsHash[l].parent.labelName;
			}
		}
		if( l && !labelsAdded[l] ){
			labelsAdded[l] = true;
			
			var elLi = this._doc.createElement("DIV");
				elLi.className = "label-quickchoice";
			
			var elTitle = this._doc.createElement("SPAN");
				elTitle.setAttribute("gtdname", labelsObjectsHash[l].leafName);
				if( !labelsObjectsHash[l].isPlaceHolder ) elTitle.setAttribute("gtdlabelname", labelsObjectsHash[l].labelName);
				elTitle.setAttribute("gtdlabelfullname", labelsObjectsHash[l].labelName);
				elTitle.innerHTML = labelsObjectsHash[l].leafName;
			elLi.appendChild( elTitle );
			
			if( labelsObjectsHash[l].childrenCount > 0 ){
				elDropdown = this._doc.createElement("IMG");
					elDropdown.src = "chrome://gtdinbox/content/combo.png";
					elDropdown.className = "label-quickchoice-dropdown";
				elLi.appendChild( elDropdown );
			}
			
			if( i > 0 ){
				var elSplit = this._doc.createElement("DIV");
					elSplit.innerHTML = ", ";
					elSplit.className = "label-quickchoice-split";
				this.el.appendChild( elSplit );
			}
			this.el.appendChild( elLi );
		}
		this.labelCount++;
	}
	if( labels.length > 0 ){
		var elClear = this._doc.createElement("DIV");
			elClear.style.clear = "both";
		this.el.appendChild( elClear );
	}
	
	this.elLabelsAll = this._gtdinboxPage._labels.getLabelsEl(this._type).el;
	this.elLabelsAll.style.display = "none";
	this.el.appendChild( this.elLabelsAll );
	
	this._elPopupCache = {};

}catch(e){
	if( GTDDEBUGMODE ) alert("LabelSelectUIInline refresh\n" + e.toString());
}
};

LabelSelectUIInline.prototype.refreshSelectedCount = function(selectedLabels){

try{
	if( selectedLabels instanceof Array ) selectedLabels = GIPROTOTYPE.arrayToHash(selectedLabels);
	
	var els = GIPROTOTYPE.getElementsByClassName(this.el, "label-quickchoice");	// Get inline label roots.
	
	var typeBucketLabels = this._gtdinboxPage._labels.typeBuckets[this._type].labels;
	var count = {c:0};
	for( var i = 0; i < els.length; i++ ){
		var labelname = els[i].firstChild.getAttribute("gtdLabelFullName");
		if( typeBucketLabels[labelname].childrenCount > 0 ){
			count.c = 0;
			typeBucketLabels[labelname].applyToChildren( function(labelObj){
					if( selectedLabels[labelObj.labelName] ) count.c++;
				}, true, true );
			els[i].firstChild.innerHTML = els[i].firstChild.innerHTML.replace(/\s\(\d+\)$/, "");
			if( count.c>0 ) els[i].firstChild.innerHTML += " (" + count.c + ")";
		}
	}
	
}catch(e){
	if( GTDDEBUGMODE ) alert("LabelSelectUIInline refreshSelectedCount\n" + e.toString());
}
};

LabelSelectUIInline.prototype._click = function(event){
try{
	var el = GIPROTOTYPE.element(event);
	
	
	if( el.className=="label-quickchoice-dropdown" ){	// Show the children of this item
				
		var label = el.previousSibling.getAttribute("gtdlabelfullname");
		
		
		var elLabels = null;
		if( this._elPopupCache[label] ){
			elLabels = this._elPopupCache[label];
		}else{
			
			
			var elLabels = this.elLabelsAll.cloneNode(true);
			
			elLabels = GIPROTOTYPE.getElementsByClassName(elLabels, "labels")[0];
			
			elLabels.style.display = "";
			for( var i = elLabels.childNodes.length - 1; i>=0; i-- ){
				var l = elLabels.childNodes[i].getAttribute("gtdlabelname");			
				if( !l || (!(l.indexOf(label)==0 && elLabels.childNodes[i].getAttribute("gtdlabelparentname"))) ){
					elLabels.removeChild( elLabels.childNodes[i] );
				}else{
					elLabels.childNodes[i].style.display = "";
				}
			}
			var elImgs = elLabels.getElementsByTagName("IMG");
			for( var i = elImgs.length - 1; i >= 0; i-- ){
				if( elImgs[i].src=="chrome://gtdinbox/content/collapsetree-closed.png" ){
					elImgs[i].src = "chrome://gtdinbox/content/collapsetree-open.png";
				}
			}
			
		}
		
		
		this.elPopup.innerHTML = "";
		this.elPopup.appendChild( elLabels );
		
		this._elPopupCache[label] = elLabels;
			
		el.parentNode.appendChild( this.elPopup );
		this.popuper.popup(el.parentNode, {'location':'relative-bottom-bottom-right'});
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("LabelSelectUIInline refresh\n" + e.toString());
}
};

LabelSelectUIInline.prototype.hideCombos = function(){

};

LabelSelectUIInline.prototype.destroy = function(){
	this._eventObservers.destroy();
	this._popuper.destroy();
};