/* Copyright Andy Mitchell 2007, 2008. No warranties */

function MoreActionsMenu(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._eventObservers = new GtdEventObservers(this);
	this._eventHandlers = new GtdEventHandlers_Mutator(this);
	this._doc = gtdinboxPage.doc;
	this._multiToOne = new MultiToOne(gtdinboxPage, 100);	
	this._queue = new GtdQueue(gtdinboxPage, this);
	this._customEntries = [];
	
	
	this._eventObservers.observe(this._doc, "keydown", function(event){
			if( event.keyCode==190) setTimeout(GIPROTOTYPE.bind(this, this.refresh), 1000);
		}, false);
	
}

MoreActionsMenu.prototype.viewChange = function(gmail){

try{
	
	/*
	if( this.elAlertBox ) this._eventObservers.stopObserving( this.elAlertBox, "DOMNodeInserted", this.alertBoxChange, false );
	this.elAlertBox = this._gtdinboxPage.gmailDOM.element("alert-box");
	this._eventObservers.observe( this.elAlertBox, "DOMNodeInserted", this.alertBoxChange, false );
	*/

	this._customEntries.length = 0; // Clear out. Means MoreActionsMenu viewChange must go first.
	
	if( this.elMoreActionsCombo ){
		this._eventObservers.stopObserving( this.elMoreActionsCombo, "click", this.moreActionsComboClick, false );
		this._eventObservers.stopObserving( this.elMoreActionsCombo, "mousedown", this.restoreScrollTop, true);
	}
	if( this.elMoreActionsComboBottom ) this._eventObservers.stopObserving( this.elMoreActionsComboBottom, "click", this.moreActionsComboClick, false );
	
	
	this.elMoreActionsCombo = this._gtdinboxPage.gmailDOM.element("action-combo");
	this.elMoreActionsComboBottom = this._gtdinboxPage.gmailDOM.element("action-combo-bottom");
	
	this._eventObservers.observe( this.elMoreActionsCombo, "click", this.moreActionsComboClick, false );
	this._eventObservers.observe( this.elMoreActionsCombo, "mousedown", this.restoreScrollTop, true);
	this._eventObservers.observe( this.elMoreActionsComboBottom, "click", this.moreActionsComboClick, false );
	
	this._eventHandlers.broadcast("view-change");
	
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu viewChange\n" + e.toString());
}

};


MoreActionsMenu.prototype.moreActionsComboClick = function(event){
	// Used to prime the dropdown for clicking
try{
	var fInhibitContextClick = GIPROTOTYPE.bindAsEventListener(this, function(event){
		if( event.button==2 ){
			GIPROTOTYPE.stop(event);
		}
		});
	
	//var callback = GIPROTOTYPE.bind(this, function(){
		try{
			var result = this._gtdinboxPage.gmailDOM.elements("action-combo-lists");
			for( var i = 0; i < result.snapshotLength; i++ ){
				var el = result.snapshotItem(i);
				
				this._eventObservers.stopObserving( el, "click", this.moreActionsComboListClick, true );
				this._eventObservers.observe( el, "click", this.moreActionsComboListClick, true );
				this._eventObservers.observe( el, "mouseup", fInhibitContextClick, true);
				this.refresh(null, el);
			}
			this.elMoreActionsList = result.snapshotItem(0);
			
			this._eventHandlers.broadcast("actions-combo-click");
			
		}catch(e){
			if( GTDDEBUGMODE ) alert("MoreActionsMenu moreActionsComboClick callback\n" + e.toString());
		}
	//});
	//setTimeout(callback, 100);
	//callback();
	
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu moreActionsComboClick\n" + e.toString());
}


};

MoreActionsMenu.prototype.moreActionsComboListClick = function(event){
	// Used to report system-wide the click event
try{

	// Find the element clicked 
	var el = GIPROTOTYPE.element(event);
	
	var ceId = el.getAttribute("gtd-more-actions-id");
	if( ceId ){	// Find the associated callback
		for( var i = 0; i < this._customEntries.length; i++ ){
			if( this._customEntries[i].id==ceId && this._customEntries[i].callback ){
				this._customEntries[i].callback();
				break;
			}
		}
	}
	
	
	// Determine if label
	var doArchive = false;
	if( !el.getAttribute("act") && el.className=="gtd-label-archive"){
		el = el.parentNode;
		doArchive = true;
	}
	var label = el.innerHTML.replace(/<.+?>/g,"");
	var safelabel = label.replace(/\"/g, "\\\"");
	var act = el.getAttribute("act") || 0;
	if( !safelabel || !(act==12 || act==13) ){
		return;
	}

	this._eventHandlers.broadcast("actionlist-manual-click", {'label':label, 'act':act, 'safelabel':safelabel, 'doArchive':doArchive});
	
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu moreActionsComboListClick\n" + e.toString());
}
};



MoreActionsMenu.prototype.clickActionCombo = function(forceRefresh){
try{
	// Used to turn it on
	if( forceRefresh ) this.elMoreActionsCombo = this._gtdinboxPage.gmailDOM.element("action-combo");
	GIPROTOTYPE.doMouseEvent(this._doc, this.elMoreActionsCombo, "mousedown");
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu clickActionCombo\n" + e.toString());
}
};


MoreActionsMenu.prototype.doMoreAction = function(f, fCallback, _qItem){
try{
	// Processes the dropdown list. If any 'f' returns true it's assumed to have clicked the item; and thus closed itself. Otherwise it is closed at the end of the process.
	// If fCallback; then it assumed to be a queued. process
	
	if( fCallback && !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){this.doMoreAction(f, fCallback, qItem)} );
		return;
	}
	
	this._eventHandlers.broadcast("doingMoreAction");
	
	
	this.elMoreActionsCombo = this._gtdinboxPage.gmailDOM.element("action-combo");
	this.clickActionCombo();
	this.elMoreActionsList = this._gtdinboxPage.gmailDOM.element("action-combo-list");
	if( this.elMoreActionsList ){
		this.elMoreActionsList.style.display = "none";		
		
		var externallyClosed = false;
		var children = this.elMoreActionsList.childNodes;
		for( var i = 0; i < children.length; i++ ){
			var el = children[i];
			externallyClosed = f(el);
			if( externallyClosed ) break;
		}
		
		if( externallyClosed==3 ){	// Something clicked to actually close it, and doesn't want to timeout
			if( _qItem ) _qItem.release();
			if( fCallback ) fCallback();
			this._eventHandlers.broadcast("doneMoreAction");
		}else if( externallyClosed==2 ){
			setTimeout( GIPROTOTYPE.bind(this, function(){
				if( _qItem ) _qItem.release();
				if( fCallback ) fCallback();
				this._eventHandlers.broadcast("doneMoreAction");
			}), 300);
		}else{
			if( this.elMoreActionsList.style.visibility!="hidden" ) GIPROTOTYPE.doMouseEvent(this._doc, this._doc.body, "mousedown", 0, -1, -1);
			setTimeout( GIPROTOTYPE.bind(this, function(){
					if( this.elMoreActionsList.style.visibility!="hidden" ) GIPROTOTYPE.doMouseEvent(this._doc, this._doc.body, "mousedown", 0, -1, -1);		
					if( _qItem ) _qItem.release();
					if( fCallback ) fCallback();
					this._eventHandlers.broadcast("doneMoreAction");
				}), 300 );
		}
	}else{
		if( _qItem ) _qItem.release();
		if( fCallback ) fCallback();
		this._eventHandlers.broadcast("doneMoreAction");
	}
		
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu doMoreAction\n" + e.toString());
}
};








MoreActionsMenu.prototype.customEntries = function(v){
	if( typeof v=="undefined" ) return this._customEntries;
	
	if( a instanceof Array ) this._customEntries = a;
};
MoreActionsMenu.prototype.addCustomEntry = function(id, name, tooltip, callback){
	this._customEntries.push( {'id':id, 'name':name, 'tooltip':tooltip, 'callback':callback} );
};
MoreActionsMenu.prototype.removeCustomEntry = function(id){
	for( var i = 0; i < this._customEntries.length; i++ ){
		if( this._customEntries[i].id==id ){
			this._customEntries.splice(i,1);
			return;
		}
	}
};


MoreActionsMenu.prototype.refresh = function(event, elCombo){
try{
	if( !elCombo ) elCombo = GIPROTOTYPE.element(event);
	if( !elCombo ) elCombo = this._gtdinboxPage.gmailDOM.element("action-combo-list");
	if( !elCombo ) return;
	
	// Change height
	var dims = GIPROTOTYPE.viewport(this._doc, this._doc.defaultView, false );
	if( parseInt(elCombo.style.top)>250 ){	// It's the second one
		//if( dims[1] > 800 ) elCombo.style.top = (parseInt(elCombo.style.top) - 600) + "px";	
		//else if( dims[1] > 600 ) elCombo.style.top = (parseInt(elCombo.style.top) - 400) + "px";	
	}else{
		if( dims[1] > 600 ) elCombo.style.height = "400px";
		if( dims[1] > 800 ) elCombo.style.height = "600px";
	}

	var fCreateEntry = GIPROTOTYPE.bind(this, function(elChild, id, name, tooltip, customClassName){
			if( !customClassName ) customClassName = "SenFne more-actions-line-item";
			var elLi = this._doc.createElement("DIV");
				elLi.className = customClassName;
				elLi.innerHTML = name;
				elLi.title = tooltip;
				elLi.setAttribute("gtd-more-actions-id", id);
				elCombo.insertBefore( elLi, elChild );
			return elLi;
		});
	
	
	
	var hasArchive = false;
	var elArchive = null;
		elArchive = this._doc.createElement("IMG");
		elArchive.src = "chrome://gtdinbox/content/folder.png";
		elArchive.className = "gtd-label-archive";
		elArchive.title = this._gtdinboxPage.stringBundle.getString("MoreActionsMenu.Archive.Tooltip");
	if( this._gtdinboxPage.gmailDOM.element("archive-button") ) hasArchive = true;
	
	
	var typeSettings = this._gtdinboxPage.settings.labels.types;
	var statusLabelsHash = {};	// [labelname] = el
	var labelsHash = {};	//[type] = {elTitle, elLabels:[]}
	for( t in this._gtdinboxPage._labels.typeBuckets ){
		labelsHash[t] = {'elTitle':this._doc.createElement("DIV"), 'elLabels':[]};
			labelsHash[t].elTitle.innerHTML = this._gtdinboxPage.stringBundle.getStringSafe("Labels.Types." + t, t);
			labelsHash[t].elTitle.className = "gtd-more-actions-title";
	}
	
	var elFirstItem = null;
	var childList = [];
	for( var i = 0; i < elCombo.childNodes.length; i++ ) childList[i] = elCombo.childNodes[i];	// CLone to stop it changing order on updates
	for( var i = 0; i < childList.length; i++ ){
		elChild = childList[i];
		
		if( !hasArchive && elChild.getAttribute("act")=="7" ) hasArchive = true;
		
		if( this._gtdinboxPage.gmailDOM.test("is-more-action-apply-label", elChild) ){	// Add custom entries // elChild.getAttribute("act")=="3"
			if( this._customEntries.length > 0 ){
				fCreateEntry(elChild, "", this._gtdinboxPage.stringBundle.getString("MoreActions.GTDHeader"), null, "more-actions-gtd-header");
				
				for( var j = 0; j < this._customEntries.length; j++ ){
					var ce = this._customEntries[j];
					fCreateEntry( elChild, ce.id, ce.name, ce.tooltip );
				}
			}
		}
		
		
		if( elChild.getAttribute("act")=="12" ){
			if( !elFirstItem ){	// Found first entry
				elFirstItem = elChild;
				
				if( labelsHash.Statuses ) elFirstItem.parentNode.insertBefore( labelsHash.Statuses.elTitle, elFirstItem );
				for( t in labelsHash ){
					if( t!="Statuses" && t!="Misc" ) elFirstItem.parentNode.insertBefore( labelsHash[t].elTitle, elFirstItem );
				}
				if( labelsHash.Misc ) elFirstItem.parentNode.insertBefore( labelsHash.Misc.elTitle, elFirstItem );
			}
			
			if( GTDDEVMODE ){
				if( hasArchive ){				
					elChild.appendChild( elArchive.cloneNode(true) );
				}
			}
			
			var type = "Misc";
			for( t in typeSettings ){
				if( typeSettings[t].prefix && elChild.innerHTML.indexOf( typeSettings[t].prefix )==0 ){
					type = t;
					break;
				}
			}
			if( type=="Statuses" ){
				statusLabelsHash[elChild.innerHTML.replace(/\<[^>]+?\>/g,"")] = elChild;
			}
			if( labelsHash[type].elLabels.length > 0 ){	// Has children
				var lastNode = labelsHash[type].elLabels[ labelsHash[type].elLabels.length - 1 ];
				lastNode.parentNode.insertBefore( elChild, lastNode.nextSibling );
			}else{	// First one
				labelsHash[type].elTitle.parentNode.insertBefore( elChild, labelsHash[type].elTitle.nextSibling );
			}
			labelsHash[type].elLabels.push(elChild);
		}
	}
	
	
	// Re-arrange Statuses
	var statusArray = this._gtdinboxPage._labels.getLabelsArray("Statuses", true).reverse();
	for( var i = 0; i < statusArray.length; i++ ){
		if( statusLabelsHash[statusArray[i]] ) labelsHash.Statuses.elTitle.parentNode.insertBefore( statusLabelsHash[statusArray[i]], labelsHash.Statuses.elTitle.nextSibling );
	}
	
	
	
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActions refresh\n" + e.toString());
}
}; 





MoreActionsMenu.prototype.addLabel = function(labelname, fCallback, _qItem){
try{
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){this.addLabel(labelname, fCallback, qItem)} );
		return;
	}
	
	this.doMoreAction(GIPROTOTYPE.bind(this, function(el){
		if( el.getAttribute("act")=="12" && el.innerHTML.replace(/<.+?>/g, "")==labelname ){
			GIPROTOTYPE.doMouseEvent(this._doc, el, "mouseup");	// Actually do the event - should close it for us
			return 3;
		}
	}));
	
	setTimeout( GIPROTOTYPE.bind(this, function(){
		if( fCallback ) fCallback();
		_qItem.release();
	}), 1000 );
}catch(e){ if( GTDDEBUGMODE ) alert("MoreActionsMenu addLabel\n" + e.toString()) }
};
MoreActionsMenu.prototype.removeLabel = function(labelname, fCallback, _qItem){
try{
	if( !_qItem ){	// Create a proper queue item
		var qItem = this._queue.addQueueItem( function(qItem){this.removeLabel(labelname, fCallback, qItem)} );
		return;
	}
	
	this.doMoreAction(GIPROTOTYPE.bind(this, function(el){
		if( el.getAttribute("act")=="13" && el.innerHTML.replace(/<.+?>/g, "")==labelname ){
			GIPROTOTYPE.doMouseEvent(this._doc, el, "mouseup");	// Actually do the event - should close it for us
			return true;
		}
	}));
	
	setTimeout( GIPROTOTYPE.bind(this, function(){
		if( fCallback ) fCallback();
		_qItem.release();
	}), 1000 );
	
}catch(e){ if( GTDDEBUGMODE ) alert("MoreActionsMenu removeLabel\n" + e.toString()) }
};




MoreActionsMenu.prototype.createLabel = function(fCallback, _qItem){
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){this.createLabel(fCallback, qItem)} );
		return;
	}
	
	
	this.doMoreAction(GIPROTOTYPE.bind(this, function(el){
		if( el.getAttribute("act")=="14" ){
			GIPROTOTYPE.doMouseEvent(this._doc, el, "mouseup");
			return true;
		}
	}));

	setTimeout( GIPROTOTYPE.bind(this, function(){
		if( fCallback ) fCallback();
		_qItem.release();
	}), 1000 );
};





MoreActionsMenu.prototype.getActiveLabels = function(fCallback, _qItem){
try{
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){this.getActiveLabels(fCallback, qItem)} );
		return;
	}
	
	
	var result = {labels:[]};
	this.doMoreAction(GIPROTOTYPE.bind(this, function(el){
			if( el.getAttribute("act")=="13" ){	// remove a label - means its applied
				result.labels.push( el.innerHTML.replace(/<.+?>/g,"") );
			}
	}));
		
	setTimeout( GIPROTOTYPE.bind(this, function(){
		if( fCallback ) fCallback(result.labels);
		_qItem.release();
	}), 500 );
	
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu getactivelabels\n" + e.toString());
}
};


MoreActionsMenu.prototype.addStar = function(fCallback, noTimeout, _qItem){
try{
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){this.addStar(fCallback, noTimeout, qItem)} );
		return;
	}
	
	this.doMoreAction(GIPROTOTYPE.bind(this, function(el){
		if( el.getAttribute("act")=="3" ){
			GIPROTOTYPE.doMouseEvent(this._doc, el, "mouseup");
			return true;
		}
	}));

	if( noTimeout ){
		if( fCallback ) fCallback();
		_qItem.release();
	}else{
		setTimeout( GIPROTOTYPE.bind(this, function(){
			if( fCallback ) fCallback();
			_qItem.release();
		}), 750 );
	}
	
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu addStar\n" + e.toString());
}
};
	
MoreActionsMenu.prototype.removeStar = function(fCallback, noTimeout, _qItem){
try{
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){this.removeStar(fCallback, noTimeout, qItem)} );
		return;
	}
	
	this.doMoreAction(GIPROTOTYPE.bind(this, function(el){
		if( el.getAttribute("act")=="4" ){
			GIPROTOTYPE.doMouseEvent(this._doc, el, "mouseup");
			return true;
		}
	}));

	if( noTimeout ){
		if( fCallback ) fCallback();
		_qItem.release();
	}else{
		setTimeout( GIPROTOTYPE.bind(this, function(){
			if( fCallback ) fCallback();
			_qItem.release();
		}), 750 );
	}
	
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu removeStar\n" + e.toString());
}
};


MoreActionsMenu.prototype.removeLabels = function(labels, fCallback){
try{
	if( labels.length > 0 ){
		var labelname = labels.shift();
		this.removeLabel(labelname, GIPROTOTYPE.bind( this, function(){this.removeLabels(labels, fCallback)}));
	}else{
		if( fCallback ) fCallback();
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu removeLabels\n" + e.toString());
}
};



MoreActionsMenu.prototype.runTest = function(verbose){
	// Can be invoked from command line. Assumes something is checked.
try{	
	this._gtdinboxPage.unsafeWindow.console.log( "runTest" );
	var labelsToRemove = [];
	var labelsToAdd = [];
	
	this.doMoreAction(GIPROTOTYPE.bind(this, function(el){
		var title = el.innerHTML.replace(/<.+?>/g, "");
		if( el.getAttribute("act")=="13" ){
			labelsToRemove.push(title);
		}
		if( el.getAttribute("act")=="12" && labelsToAdd.length < 4 ){
			labelsToAdd.push(title);
		}
	}), GIPROTOTYPE.bind(this, function(){
		try{
			this._gtdinboxPage.unsafeWindow.console.log("completed reading labels");
			this._gtdinboxPage.unsafeWindow.console.log(labelsToRemove);
			this._gtdinboxPage.unsafeWindow.console.log(labelsToAdd);
			if( verbose && !confirm("Read Labels. Continue?") ) return;
			this._runTest(labelsToRemove, labelsToAdd, verbose);
		}catch(e){ if( GTDDEBUGMODE ) alert("runTest callback\n" + e.toString()) }
	}))
}catch(e){ if( GTDDEBUGMODE ) alert("runTest\n" + e.toString()) }
};
MoreActionsMenu.prototype._runTest = function(labelsToRemove, labelsToAdd, verbose){
try{
	if( labelsToRemove.length > 0 ){
		if( verbose && !confirm("Going to remove label " + labelsToRemove[0] + ". Continue?") ) return;
		this._gtdinboxPage.unsafeWindow.console.log("removing label: " + labelsToRemove[0] + " (" + labelsToRemove + ")");
		this.removeLabel(labelsToRemove.shift(), GIPROTOTYPE.bind(this, function(){this._runTest(labelsToRemove, labelsToAdd, verbose)}));
	}else if( labelsToAdd.length > 0 ){
		this._gtdinboxPage.unsafeWindow.console.log("adding label: " + labelsToAdd[0] + " (" + labelsToAdd + ")");
		this.addLabel(labelsToAdd.shift(), GIPROTOTYPE.bind(this, function(){this._runTest(labelsToRemove, labelsToAdd, verbose)}));
	}else{
		this._gtdinboxPage.unsafeWindow.console.log("adding star");
		this.addStar( GIPROTOTYPE.bind( this, function(){
			this._gtdinboxPage.unsafeWindow.console.log("removing star");
			this.removeStar( GIPROTOTYPE.bind( this, function(){
				alert("done!");
			}));
		}));
	}
}catch(e){ if( GTDDEBUGMODE ) alert("_runTest\n" + e.toString()) }
};














/*
MoreActionsMenu.prototype.labelThread = function(options, qItem){
	// options: {fPreAdd, fCallback, 
		
try{
	
	// Queue it up:
	if( !qItem ){	// no callback
		var qItem = {};
		qItem.options = options;
		qItem.start = {'callee':this, 'callback':this.labelThread, args:[qItem.options, qItem]};
		qItem.callback = options.callback;
		qItem.test = GIPROTOTYPE.bind(this, function(qItem){
			try{
				var msg = this.elAlertBox? this.elAlertBox.innerHTML : "";
				if( msg==this.elAlertBox_LastMsg ) return;
				if( msg.indexOf( "\"" + qItem.options.labelname + "\"" )>-1 ){
					this.elAlertBox_LastMsg = msg;
					return true;
				}
				}catch(e){
					if( GTDDEBUGMODE ) alert("MoreActionsMenu labelThread test\n" + e.toString());
				}
			});
		this._queue.createQueueItem(qItem);
		return;
	}

	// Load common use:
	var labelname = options.labelname;
	var on = options.on;

	// Process each menu item to extract the required element:
	var result = {act:0, elAction:null};
	var fLI = GIPROTOTYPE.bind(this, function(el){
			if( el.innerHTML.replace(/<.+?>/g, "")==labelname ){
				result.act = el.getAttribute("act");
				result.elAction = el;
				if( el.getAttribute("act")=="13" ) return true;	// remove label overrides (remove & add can be on same label)
			}
		});
	this.doMoreAction(fLI, false, true);
	var elAction = result.elAction;
	var act = result.act;
	

	
	if( elAction && ((typeof on=="undefined") || (act==12 && on) || (act==13 && !on)) ){	// Toggle or turn on/off
		if( options.fPreAdd ) options.fPreAdd();
		
		
		GIPROTOTYPE.doMouseEvent(this._doc, elAction, "mouseup");	// Actually do the event
		
		options.act = act;
		qItem.act = act;
		setTimeout( GIPROTOTYPE.bind(this, function(){this._queue.nextQueueItem()}), 2500 );	// call to make sure deadwood is cleared
	}else{
		options.act = 0;
		qItem.act = 0;
		if( !elAction ) this.clickActionCombo();	// turn it off
		this._queue.clearQueueItem(qItem);
	}
		
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu labelThread\n" + e.toString());
}
	
	
		
};


MoreActionsMenu.prototype.alertBoxChange = function(event){
	this._multiToOne.process("alert-box", GIPROTOTYPE.bind(this, function(){
		this._queue.nextQueueItem();
	}));
	return;

};


MoreActionsMenu.prototype.createLabel = function(qItem){

	if( !qItem ){	// no callback
		var qItem = {};
		qItem.start = {'callee':this, 'callback':this.createLabel, args:[qItem]};

		this._queue.createQueueItem(qItem);
		return;
	}

	var fLI = GIPROTOTYPE.bind(this, function(el){
			if( el.getAttribute("act")=="14" ){
				GIPROTOTYPE.doMouseEvent(this._doc, el, "mouseup");
				return true;
			}
		});
	this.doMoreAction(fLI);
	
	
	this._queue.clearQueueItem(qItem);
};
MoreActionsMenu.prototype.createLabelAjax = function(labelname){
try{
	if( !labelname ) labelname = prompt(this._gtdinboxPage.stringBundle.getString("Labels.CreateLabel"));	
	if( !labelname ) return;
	
	var finalCallback = GIPROTOTYPE.bind(this, function(){
			this._gtdinboxPage._labels.addNewLabel(labelname);
		});
	this._gtdinboxPage.gmailDOM.addLabel(labelname, null, finalCallback);


}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu createlabelajax\n" + e.toString());
}
};

MoreActionsMenu.prototype.getActiveLabels = function(callee, callback, qItem){
try{
	if( !qItem ){	// no callback
		var qItem = {};
		qItem.options = {'callee':callee, 'callback':callback};	// external
		qItem.start = {'callee':this, 'callback':this.getActiveLabels, args:[null, null, qItem]};

		this._queue.createQueueItem(qItem); 
		return; 
	}
	
	
	var result = {labels:[]};
	var fLI = GIPROTOTYPE.bind(this, function(el){
			if( el.getAttribute("act")=="13" ){	// remove a label - means its applied
				result.labels.push( el.innerHTML.replace(/<.+?>/g,"") );
			}
		});
	this.doMoreAction(fLI, true);
		
	// Now callback
	if( qItem.options.callback ) qItem.options.callback.call(qItem.options.callee, result.labels);
	//if( qItem.options.callback ) qItem.options.callback(result.labels);
	//return result.labels;
	
	this._queue.clearQueueItem(qItem);
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu getactivelabels\n" + e.toString());
}
};

MoreActionsMenu.prototype.starSelectedMessage = function(options, qItem){
try{

	if( !qItem ){	// no callback
		var qItem = {};
		qItem.options = options;
		qItem.callback = GIPROTOTYPE.bind(this, function(){
				if( options.callback && (typeof options.callback=="function") ) setTimeout( options.callback, 800 );	// give it time to star off
			});
		qItem.start = {'callee':this, 'callback':this.starSelectedMessage, args:[options, qItem]};
		
		this._queue.createQueueItem(qItem); 
		return; 
	}
	
	
	var find = options.starOn? "3" : "4";
	var fLI = GIPROTOTYPE.bind(this, function(el){
			if( el.getAttribute("act")==find ){	
				GIPROTOTYPE.doMouseEvent(this._doc, el, "mouseup");
				return true;
			}
		});
	this.doMoreAction(fLI, true);
			
	this._queue.clearQueueItem(qItem);	// does the callback

}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu starSelectedMessage\n" + e.toString());
}
};

*/