/* Copyright Andy Mitchell 2007, 2008. No warranties */

function NewsBox(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
	this._eventObservers = new GtdEventObservers(this);
	
	this.create();
}

NewsBox.prototype.create = function(){
	this.el = this._doc.createElement("DIV");
	this.el.className = "newsbox";
	this.el.innerHTML = "<div class='title'>" + this._gtdinboxPage.stringBundle.getString("Sidebar.About.News") + "</div>";	
	this.el.style.display = "none";
	
	this._eventObservers.observe( this.el, "mousedown", this._click, false);
};

NewsBox.prototype.refresh = function(){
try{
	if( !this.news ) this.news = {};

	this.newsHistory = gtdJson.parse( this._gtdinboxPage.gtdinboxBrowser.options.getOption("char", "gtdinbox.newsHistory", "") );
	if( !this.newsHistory ) this.newsHistory = {};

	var newItems = 0;
	var url = "http://www.google.com/uds/Gfeeds?v=1.0&output=json&q=" + encodeURIComponent("http://feeds.feedburner.com/ProductiveFirefox");
	var callback = GIPROTOTYPE.bind(this, function(jsonStr){
			var rss = gtdJson.parse(jsonStr);
			if( rss.responseData ){
				var entries = rss.responseData.feed.entries;
					if( entries.length > 3 ) entries.length = 3;
				var elUl = this._doc.createElement("DIV");
					elUl.className = "news-line-items";
				for( var i = 0; i < entries.length; i++ ){
					var elLi = this._doc.createElement("DIV");
						elLi.innerHTML = "<a href=\"" + entries[i].link + "\" target='_blank'>" + entries[i].title + "</a>";
						elLi.title = entries[i].contentSnippet;
						elLi.className = "line-item";
					elUl.appendChild( elLi );
					if( !this.newsHistory[entries[i].link] ){
						GIPROTOTYPE.addClassName(elLi, "new-item");
						newItems++;
					}
					this.news[entries[i].link] = elLi;
				}
				this.el.appendChild(elUl);
				if( entries.length>0 ){
					this.el.style.display = "";
				}else{
					
				}
			}else{
				this.el.style.display = "none";
			}
		});
	var req = new XMLHttpRequest();
	req.open('GET', url, true);
	req.onreadystatechange = GIPROTOTYPE.bind(this, function(aEvt){
		try{
		if (req.readyState==4) {
			if( req.status==200 ){
				callback(req.responseText);
			}
		}
		}catch(e){
			if( GTDDEBUGMODE ) alert("NewsBox statechange\n" + e.toString());
		}
	});
	req.send(null);
}catch(e){
	if( GTDDEBUGMODE ) alert("NewsBox refresh\n" + e.toString());
}
};

NewsBox.prototype._click = function(event){
try{
	// Mark all as read
	var changed = false;
	var el = GIPROTOTYPE.element(event);
	if( el.nodeName=="A" ){
		for( n in this.news ){
			if( !this.newsHistory[n] ){
				this.newsHistory[n] = true;
				GIPROTOTYPE.removeClassName( this.news[n], "new-item" );
				changed = true;
			}
		}
	}
	if( changed ){
		this._gtdinboxPage.gtdinboxBrowser.options.setOption("char", "gtdinbox.newsHistory", gtdJson.stringify( this.newsHistory ));
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("NewsBox _click\n" + e.toString());
}
};