function PrintViewUI(gtdinboxBrowser, doc){

	this.gtdinboxBrowser = gtdinboxBrowser;
	this.doc = doc;

	var template = [];
	template.push("<div style='font-size:0.8em;height:288px;width:480px;margin-bottom: 30px;'>");
	template.push("<div style='float:left;width:150px;'><gtd=rowNamesHTML></div>");
	template.push("<div style='float:left;width:250px;'><gtd=subject></div>");
	template.push("<div style='float:left;width:80px;'><gtd=rowDateHTML></div>");
	template.push("<div style='clear:both'></div>");
	template.push("div style='width:480px'><gtd=rowSnippetHTML></div>");
	tempate.push("</div>");
	this.template = template.join("\n");

	this.render();	
};

PrintViewUI.prototype.render = function(){
	// Extract the id and groupby from the URL
	// Retrieve the appropriate thread list and sort it
	// Render each thread
	
	var url = this.doc.location.href;
	var m = url.match(/id\=(\d+)/);
	var id = m? m[1] : 0;
	var m = url.match(/groupby=(\w+)($|&)/);
	var group = m? m[1] : "";
	
	
	if( !id ) return;
	
	var printerData = this.gtdinboxBrowser.printers[id];
	if( !printerData ) return;
	var threadList = printerData.threadList;
	var gtdinboxPage = printerData.gtdinboxPage;
	var settings = printerData.gtdinboxPage.settings;
	
	if( group ){	// Put items into ordered buckets and render
		var buckets = {};
		var projectPrefix = settings.labels.types.Projects.prefix;
		var contextPrefix = settings.labels.types.Contexts.prefix;
		var misc = gtdinboxPage.stringBundle.getString("Print.Categories.Misc");
		for( var i = 0; i < threadList._threads.length; i++ ){
			var thread = threadList._threads[i];
			switch(group){
				case "contact":
					var names = thread.getNames(null, true);
					for( var j = 0; j < names.length; j++ ){
						if( !buckets[names[1]] ) buckets[names[1]] = {name:(names[0] + " (" + names[1] + ")"), threads:[]};
						buckets[names[1]].threads.push(thread);
					}
					break;
				case "project":
					var labels = thread.getLabels();
					var found = false;
					for( var j = 0; j < labels.length; j++ ){
						if( labels[j].indexOf(projectPrefix)==0 ){
							if( !buckets[labels[j]] ) buckets[labels[j]] = {name:labels[j].replace(projectPrefix, ""), threads:[]};
							buckets[labels[j]].threads.push(thread);
							found = true;
						}
					}
					if( !found ){
						if( !buckets[misc] ) buckets[misc] = {name:misc, threads:[]};
						buckets[misc].threads.push(thread);
					}
					break;
				case "context":
					var labels = thread.getLabels();
					var found = false;
					for( var j = 0; j < labels.length; j++ ){
						if( labels[j].indexOf(contextPrefix)==0 ){
							if( !buckets[labels[j]] ) buckets[labels[j]] = {name:labels[j].replace(contextPrefix, ""), threads:[]};
							buckets[labels[j]].threads.push(thread);
							found = true;
						}
					}
					if( !found ){
						if( !buckets[misc] ) buckets[misc] = {name:misc, threads:[]};
						buckets[misc].threads.push(thread);
					}
					break;
			}
			for( b in buckets ){
				this.renderSection( buckets[b].name );
				for( var i = 0; i < buckets[b].threads.length; i++ ){
					this.renderThread( this.template, buckets[b].threads[i] );
				}
			}
		}
		
	}else{	// Just render thread list:
		for( var i = 0; i < threadList._threads.length; i++ ){
			this.renderThread( this.template, threadList._threads[i] );
		}
	}
};

PrintViewUI.prototype.renderSection = function(section){
	var elSection = this.doc.createElement("H3");
	elSection.innerHTML = section;
	this.doc.body.appendChild( elSection );
};

PrintViewUI.prototype.renderThread = function(template, thread){
	// Parse out all <gtd=name> items in the html and replace with representative data on the thread
	var m = template.match(/<gtd\=[\w\d]+?>/gi);
	if( m ){
		for( var i = 0; i < m.length; i++ ){
			var m2 = m[i].match(/<gtd\=([\w\d]+)>/i);
			if( m2 ){
				var variable = m2[1];
				if( typeof thread[variable]=="string" ){
					template.replace( m2[0], thread[variable] );
				}
			}
		}
	}
	
	this.doc.body.innerHTML += template;
};