/* Copyright Andy Mitchell 2007, 2008. No warranties */

function RecentItems(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
};

RecentItems.prototype._extractArray = function(arr, prefix, number){
	if( !number ) number = arr.length;
	var newArr = [];
	var typeSettings = this._gtdinboxPage.settings.labels.types;
	for( var i = 0; i < arr.length; i++ ){
		if( prefix ){
			if( arr[i].indexOf(prefix)==0 ){
				newArr.push(arr[i]);
				number++;
			}
		}else{	// Misc
			var isMisc = true;
			for( t in typeSettings ){
				if( arr[i].indexOf( typeSettings[t].prefix )==0 ){
					isMisc = false;
					break;
				}
			}
			if( isMisc ){
				newArr.push(arr[i]);
				number++;
			}
		}
	}
	
	return newArr;
};

RecentItems.prototype.labels = function(number){
	// Return [label]
	if( !this._gtdinboxPage.settings.recent || !this._gtdinboxPage.settings.recent.labels ) return [];
	return this._extractArray( this._gtdinboxPage.settings.recent.labels, null, number );
};

RecentItems.prototype.labelsByType = function(type, number){
try{

	
	

	var prefix = this._gtdinboxPage.settings.labels.types[type].prefix || "";
	if( !this._gtdinboxPage.settings.recent || !this._gtdinboxPage.settings.recent.labels ) return [];
	
	var labels = this._gtdinboxPage.settings.recent.labels;
		
	if( prefix ){
		for( var i = labels.length - 1; i >= 0; i-- ){
			if( !this._gtdinboxPage._labels.hasLabel(labels[i]) && labels[i].indexOf(prefix)==0 ){
				labels.splice(i, 1);
			}
		}
	}
	
	return this._extractArray( this._gtdinboxPage.settings.recent.labels, prefix, number );
	
}catch(e){
	if( GTDDEBUGMODE ) alert( "RecentItems labelsByType\n" + e.toString() );
}
};


RecentItems.prototype.threads = function(number){
	// Return [{id:,subject:}]
	if( !this._gtdinboxPage.settings.recent || !this._gtdinboxPage.settings.recent.threads ) return [];
	if( !number ) number = 5;
	var arr = [];
	for( var i = 0; i < this._gtdinboxPage.settings.recent.threads.length && i < number; i++ ){
		arr.push( this._gtdinboxPage.settings.recent.threads[i] );
	}
	return arr;
};

RecentItems.prototype.addLabel = function(label){
	if( !this._gtdinboxPage.settings.recent ) this._gtdinboxPage.settings.recent = {};
	if( !this._gtdinboxPage.settings.recent.labels ) this._gtdinboxPage.settings.recent.labels = [];
	
	for( var i = 0; i < this._gtdinboxPage.settings.recent.labels.length; i++ ) if( this._gtdinboxPage.settings.recent.labels[i]==label ) return;
	
	this._gtdinboxPage.settings.recent.labels.unshift(label);
	//if( this._gtdinboxPage.settings.recent.labels.length > 30 ) this._gtdinboxPage.settings.recent.labels.length = 30;
	this._trimLabelList();
	this._gtdinboxPage.saveSettings();
};

RecentItems.prototype._trimLabelList = function(){
	// Reduce anything over 5 in length
	
	var labels = this._gtdinboxPage.settings.recent.labels;
	var typeCount = {};
	var typeSettings = this._gtdinboxPage.settings.labels.types;
	for( var i = 0; i < labels.length; i++ ){
		for( t in typeSettings ){
			if( !typeCount[t] ) typeCount[t] = 0;
			if( t=="Misc" ){
				var isMisc = true;
				for( t1 in typeSettings ){
					if( labels[i].indexOf( typeSettings[t1].prefix )==0 ){
						isMisc = false;
						break;
					}
				}
				if( isMisc ){
					typeCount[t]++;
				}
			}else{
				if( labels[i].indexOf( typeSettings[t].prefix )==0 ){
					typeCount[t]++;
				}
			}
			if( typeCount[t] > 6 ){
				labels.splice(i,1);
				i--;
				break;
			}
		}
	}
	this._gtdinboxPage.settings.recent.labels = labels;
};

RecentItems.prototype.addThread = function(thread){
	if( !this._gtdinboxPage.settings.recent ) this._gtdinboxPage.settings.recent = {};
	if( !this._gtdinboxPage.settings.recent.threads ) this._gtdinboxPage.settings.recent.threads = [];
	
	for( var i = 0; i < this._gtdinboxPage.settings.recent.threads.length; i++ ) if( this._gtdinboxPage.settings.recent.threads[i].id==thread.id ) return;
	
	this._gtdinboxPage.settings.recent.threads.unshift({id:thread.id, subject:thread.subject});
	if( this._gtdinboxPage.settings.recent.threads.length > 5 ) this._gtdinboxPage.settings.recent.threads.length = 5;
	this._gtdinboxPage.saveSettings();
};