/* Copyright Andy Mitchell 2007, 2008. No warranties */

function GtdQueue(gtdinboxPage, caller){
	this._gtdinboxPage = gtdinboxPage;
	this._caller = caller;
	this._queue = [];
	this._currentQueueItem = null;
}

GtdQueue.prototype.addQueueItem = function(fStart){
	var id = (new Date()).valueOf() + parseInt( Math.random() * 100 );
	var qItem = {'id':id, 'fStart':GIPROTOTYPE.bind( this._caller, fStart )};
		qItem.release = GIPROTOTYPE.bind(this, function(){
				this.releaseQItem(id);
			});
	this._queue.push(qItem);
	this._tryNext();
	return qItem;
}

GtdQueue.prototype._tryNext = function(){
	if( this._queue.length==0 ) return;
	if( this._queue[0]==this._currentQueueItem ) return;	// In progress
	
	this._currentQueueItem = this._queue[0];
	this._currentQueueItem.fStart(this._currentQueueItem);
};

GtdQueue.prototype.getQItemById = function(id){
	for( var i = 0; i < this._queue.length; i++ ){
		if( this._queue[i].id==id ) return this._queue[i];
	}
};

GtdQueue.prototype.releaseQItem = function(qItem){
	
	if( typeof qItem=="string" || typeof qItem=="number" ) qItem = this.getQItemById(qItem);
	if( !qItem ) return;
	for( var i = (this._queue.length - 1); i >= 0; i-- ){
		if( this._queue[i]==qItem ){
			this._queue.splice(i,1);
		}
	}
	if( this._currentQueueItem==qItem ) this._currentQueueItem = null;
	this._tryNext();
};






/*
function GtdQueue(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._queue = [];
}

GtdQueue.prototype.createQueueItemManual = function(f, fArgs, callee, test, callback){
	// Queue up f, with arguments fArgs, in context callee, with the test for completion, and an optional callback. 
	var queueItem = {'start':{'callee':callee, 'callback':f, 'args':fArgs}, 'test':test, 'callback':callback};
	this.createQueueItem(queueItem);
	return queueItem;
}
GtdQueue.prototype.createQueueItem = function(qItem){
try{
	// qItem expected to have {start, test, callback} at least	
	qItem.callee = qItem.callee || this;

	
	this._queue.push(qItem);
	this.nextQueueItem();
}catch(e){
	if( GTDDEBUGMODE ) alert("GtdQueue _createQueueItem\n" + e.toString());
}
};
GtdQueue.prototype.clearQueueItem = function(qItem){
try{
	for( var i = this._queue.length - 1; i>=0; i-- ){
		if( this._queue[i]==qItem ){
			if( this._queue[i].callback ) this._queue[i].callback(this._queue[i].act);
			this._queue.splice(i, 1);
		}
	}
	if( this._queueItem==qItem ){
		this._queueItem = null;
		this._queueLastClear = (new Date()).valueOf();
	}
	this.nextQueueItem();
}catch(e){
	if( GTDDEBUGMODE ) alert("GtdQueue _clearQueueItem\n" + e.toString());
}
};
GtdQueue.prototype.nextQueueItem = function(){
try{
	// Clear out aging items, and test active queued items:
	var d = (new Date()).valueOf() - 1500;
	var toClear = [];
	
	var qItem = this._queueItem;
	if( qItem && qItem.test && qItem.test(qItem) ){
		toClear.push(qItem);
	}
	
	for( var i = 0; i < this._queue.length; i++ ){
		var qItem = this._queue[i];
		if( qItem.date < d ){
			toClear.push(qItem);
		}
	}
	for( var i = 0; i < toClear.length; i++ ) this.clearQueueItem(toClear[i]);
	
	// Try the next one:
	this._tryNextQueueItem();
}catch(e){
	if( GTDDEBUGMODE ) alert("GtdQueue _nextQueueItem\n" + e.toString());
}
};
GtdQueue.prototype._tryNextQueueItem = function(){
try{
	if( !this._queueItem && this._queue.length > 0 ){
		this._queueItem = this._queue[0];
		this._queueItem.date = (new Date()).valueOf();
		//this._queueItem.start(this._queueItem);
		if( this._queueItem.start ){
			var qItem = this._queueItem;
			var d = (new Date()).valueOf() - 300;
			if( (this._queueLastClear||0) > d ){	// Something finished recently
				setTimeout( function(){	
					qItem.start.callback.apply( qItem.start.callee, qItem.start.args );
					}, 300);
			}else{
				qItem.start.callback.apply( qItem.start.callee, qItem.start.args );
			}
		}
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("GtdQueue _tryNextQueueItem\n" + e.toString());
}
};
*/