/* Copyright Andy Mitchell 2007, 2008. No warranties */

function GtdMouseWheel(domElement){
	this.eventListeners = new GtdEventObservers(this);
	this.eventHandlers = new GtdEventHandlers_Mutator(this);
	
	if( domElement ){
		this.init(domElement);
	}
}
GtdMouseWheel.prototype.init = function(domElement){
	this.eventListeners.reset();
	this.domElement = domElement;// || window;
	this.activate();
};

GtdMouseWheel.prototype.activate = function(){
	this.eventListeners.reset();
	this.eventListeners.observe( this.domElement, "DOMMouseScroll", this.wheelScroll, false);
};

GtdMouseWheel.prototype.deactivate = function(){
	this.eventListeners.stopObserving( this.domElement, "DOMMouseScroll", this.wheelScroll, false);
};

GtdMouseWheel.prototype.wheelScroll = function(event){
	var delta = 0;
	if (!event) event = window.event;
	if (event.wheelDelta) {
		delta = event.wheelDelta/120; 
		if (window.opera) delta = -delta;
	} else if (event.detail) {
		delta = -event.detail/3;
	}
	
	if (delta){
		GIPROTOTYPE.stop(event);
		
		if( delta > 0 ){
			this.eventHandlers.broadcast("scrollup");
		}else{
			this.eventHandlers.broadcast("scrolldown");
		}
	}
};

GtdMouseWheel.prototype.destroy = function(){
	this.eventListeners.destroy();
}